summaryrefslogtreecommitdiffstats
path: root/git/bin/git-repo-repack
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-08-28 04:43:24 +0000
committerDaniel Baumann <daniel.baumann@open-infrastructure.net>2021-08-28 09:20:08 +0000
commitff14e9779518c60d9fe2321945a17fdd39a6e2ff (patch)
tree34b8d48ec068f0373d52536b5bb1d265c8e7469e /git/bin/git-repo-repack
parentAdding dehydrated tools. (diff)
downloadservice-tools-ff14e9779518c60d9fe2321945a17fdd39a6e2ff.tar.xz
service-tools-ff14e9779518c60d9fe2321945a17fdd39a6e2ff.zip
Adding git tools.
Signed-off-by: Daniel Baumann <daniel.baumann@open-infrastructure.net>
Diffstat (limited to 'git/bin/git-repo-repack')
-rwxr-xr-xgit/bin/git-repo-repack45
1 files changed, 45 insertions, 0 deletions
diff --git a/git/bin/git-repo-repack b/git/bin/git-repo-repack
new file mode 100755
index 0000000..d9d7357
--- /dev/null
+++ b/git/bin/git-repo-repack
@@ -0,0 +1,45 @@
+#!/bin/sh
+
+set -e
+
+case "${1}" in
+ --quiet)
+ QUIET="true"
+ shift
+
+ GIT_REPACK_OPTIONS="-q"
+ GIT_GC_OPTIONS="--quiet"
+ ;;
+esac
+
+REPOSITORIES="${*}"
+
+if [ -z "${REPOSITORIES}" ]
+then
+ if [ ! -e HEAD ]
+ then
+ REPOSITORIES="*.git"
+ else
+ REPOSITORIES="$(pwd)"
+ fi
+fi
+
+for REPOSITORY in ${REPOSITORIES}
+do
+ [ "${QUIET}" ] || echo "================================================================================"
+ [ "${QUIET}" ] || echo "${REPOSITORY}"
+ [ "${QUIET}" ] || echo "================================================================================"
+
+ cd "${REPOSITORY}"
+ git repack "${GIT_REPACK_OPTIONS}" -a -b -d -f -F
+ git gc "${GIT_GC_OPTIONS}" --aggressive --prune
+ cd "${OLDPWD}"
+
+ if [ "$(id -u)" -eq "0" ]
+ then
+ USER_ID="$(stat -c %u "${REPOSITORY}")"
+ GROUP_ID="$(stat -c %g "${REPOSITORY}")"
+
+ chown "${USER_ID}":"${GROUP_ID}" "${REPOSITORY}" -R
+ fi
+done